Gecode::NonLinIntExpr Class Referenceabstract

Base class for non-linear expressions over integer variables. More...

`#include <minimodel.hh>`

## Public Member Functions

virtual IntVar | post (Home home, IntVar *ret, const IntPropLevels &ipls) const =0
| Return variable constrained to be equal to the expression.
virtual void | post (Home home, IntRelType irt, int c, const IntPropLevels &ipls) const =0
| Post expression to be in relation irt with c.
virtual void | post (Home home, IntRelType irt, int c, BoolVar b, const IntPropLevels &ipls) const =0
| Post reified expression to be in relation irt with c.
virtual | ~NonLinIntExpr (void)
| Destructor.
void * | operator new (size_t s)
| Memory management.
void | operator delete (void *p, size_t s)
| Memory management.

## Static Public Member Functions

static IntVar | result (Home home, IntVar *x)
| Return fresh variable if x is null, x otherwise.
static IntVar | result (Home home, IntVar *x, IntVar y)
| Constrain x to be equal to y if x is not null.

## Detailed Description

Base class for non-linear expressions over integer variables.

Definition at line 215 of file minimodel.hh.

## Constructor & Destructor Documentation

## ~NonLinIntExpr()

Gecode::NonLinIntExpr::~NonLinIntExpr | ( | void |  | ) |

inline virtual

Destructor.

Definition at line 37 of file int-expr.hpp.

## Member Function Documentation

## post() [1/3]

virtual IntVar Gecode::NonLinIntExpr::post | ( | Home | home,
|  | IntVar * | ret,
|  | const IntPropLevels & | ipls ) const

pure virtual

Return variable constrained to be equal to the expression.

Implemented in Gecode::MiniModel::ArithNonLinIntExpr, and Gecode::MiniModel::SetNonLinIntExpr.

## post() [2/3]

virtual void Gecode::NonLinIntExpr::post | ( | Home | home,
|  | IntRelType | irt,
|  | int | c,
|  | const IntPropLevels & | ipls ) const

pure virtual

Post expression to be in relation irt with c.

Implemented in Gecode::MiniModel::ArithNonLinIntExpr, and Gecode::MiniModel::SetNonLinIntExpr.

## post() [3/3]

virtual void Gecode::NonLinIntExpr::post | ( | Home | home,
|  | IntRelType | irt,
|  | int | c,
|  | BoolVar | b,
|  | const IntPropLevels & | ipls ) const

pure virtual

Post reified expression to be in relation irt with c.

Implemented in Gecode::MiniModel::ArithNonLinIntExpr, and Gecode::MiniModel::SetNonLinIntExpr.

## result() [1/2]

IntVar Gecode::NonLinIntExpr::result | ( | Home | home,
|  | IntVar * | x )

inline static

Return fresh variable if x is null, x otherwise.

Definition at line 40 of file int-expr.hpp.

## result() [2/2]

IntVar Gecode::NonLinIntExpr::result | ( | Home | home,
|  | IntVar * | x,
|  | IntVar | y )

inline static

Constrain x to be equal to y if x is not null.

Definition at line 46 of file int-expr.hpp.

## operator new()

void * Gecode::NonLinIntExpr::operator new | ( | size_t | s | ) |

inline

Memory management.

Definition at line 53 of file int-expr.hpp.

## operator delete()

void Gecode::NonLinIntExpr::operator delete | ( | void * | p,
|  | size_t | s )

inline

Memory management.

Definition at line 57 of file int-expr.hpp.

The documentation for this class was generated from the following files:

- gecode/minimodel.hh
- gecode/minimodel/int-expr.hpp